

procedure SYNTAX_ERROR;
begin
  clrscr;
  gotoxy (32,13);
  writeln (chr ($07), '* Syntaxfehler *');
  delay(2000);
end;


function EPROM_ERROR_CONT (ADR : real; DATA1, DATA2 : integer) : boolean;
var     ANSWER : char;
begin;
if (not LAUF) then begin
gotoxy(1,1);
  write (chr ($07),'* Adresse : $ ', HEX_ADR (trunc(ADR)));
  if DATA1 < $100 then write ('   EPROM-DATA : ', HEX (DATA1));
  if DATA2 < $100 then write ('   RAM-DATA : ', HEX (DATA2));
  write ('    weiter (J/N/L) ?  [J]  ');
  read (kbd, ANSWER);
  if ANSWER = #13 then ANSWER := 'J';
  EPROM_ERROR_FLAG := true;
  if EPROM_ERROR_FLAG = true THEN begin
    gotoxy (1,1);
    clreol;
  end;
  LAUF := ANSWER in ['L','l'];
  end;
  error_no := error_no + 1;
  EPROM_ERROR_CONT := ANSWER in ['J','j','L','l'];
end;

overlay procedure TYPE_CMD;
begin
  H4 := 0;
  case PARAM_NO of
  1 : with EPROM do
        writeln;
  2 : begin
        W := 1;
        while (KNOWN_EPROMS [W].TNR <> PARAM [2]) and (W <= EPROM_TYPES)
        do W := W + 1;
        if W <= EPROM_TYPES then EPROM := KNOWN_EPROMS [W]
        else
        begin
          gotoxy (26,13);
          writeln (chr($07), '* EPROMtyp nicht definiert *');
          delay(2000);
        end;
      end;
  else SYNTAX_ERROR;
  end;
  if EPROM.LEN = $4000 then begin
    EPROM.LEN := $3FFF;
    H4 := 1;
  end;
end;

overlay procedure TEST_CMD;
begin
  gotoxy(1,11);
  writeln ('                               LOESCHTEST LAEUFT.....');
  writeln;
  writeln ('                                  BITTE WARTEN !');
  writeln;
  writeln ('                             EPROM IM SOCKEL BELASSEN');
  gotoxy(1,1);
  LAUF:=false;
  error_no:=0;
  case PARAM_NO of
  1 : with EPROM do
      begin
        I := 0;
        CONTINUE := true;
        EPROM_ERROR_FLAG := false;
        repeat
          DATA_EPROM := GET_EPROM (I);
          if DATA_EPROM <> EMPTY
          then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, $100);
          I := I + 1;
        until not (I < EPROM.LEN + H4) or not CONTINUE;
        if EPROM_ERROR_FLAG then writeln;
        RESET_SOCKET;
      end;
  else SYNTAX_ERROR;
  end;
  if (error_no <> 0) then
  begin;
  clrscr;gotoxy(30,12);write (chr(7),error_no,' fehlerhafte Bytes');
  delay (4000);
  end;
end;

overlay procedure VERIFY_CMD;
begin
gotoxy(1,11);
writeln ('                    VERGLEICH EPROM-SPEICHERBEREICH LAEUFT.....');
writeln;
writeln ('                                  BITTE WARTEN !');
writeln;
writeln ('                             EPROM IM SOCKEL BELASSEN');
LAUF:=false;
error_no:=0;
gotoxy(1,1);
  H1 := DECIMAL_CHECK (PARAM [2], E1);
  E2 := 1;
  case PARAM_NO of
  2 : begin
        H2 := H1 + EPROM.LEN - 1 + H4;
        if H2 <= BUF_END then E2 := 0;
      end;
  4 : begin
        if pos (PARAM [3], 'BIS') = 1
        then H2 := DECIMAL_CHECK (PARAM [4], E2);
      end;
  else
  end;
  if (E1 + E2 = 0) and (H2 - H1 <= EPROM.LEN - 1 + H4) then
  begin
    I := 0;
    CONTINUE := true;
    EPROM_ERROR_FLAG := false;
    repeat
      DATA_RAM := BUFFER [trunc (H1)];
      DATA_EPROM := GET_EPROM (I);
      if DATA_RAM <> DATA_EPROM
      then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, DATA_RAM);
      I := I + 1;
      H1 := H1 + 1;
    until (H1 > H2) or not CONTINUE;
    if EPROM_ERROR_FLAG then writeln;
    RESET_SOCKET;
  end
  else SYNTAX_ERROR;
  if (error_no <> 0) then
  begin;
  clrscr;gotoxy(30,12);write (chr(7),error_no,' fehlerhafte Bytes');
  delay (4000);
  end;
end;

overlay procedure PROGRAM_CMD;
begin
  EPROM := KNOWN_EPROMS [W];
  N1 := 256;
  N3 := EPROM.TIME;
  H1 := DECIMAL_CHECK (PARAM [2], E1);
  H3 := H1;
  E2 := 1;
  if EPROM.LEN = $4000 then begin
    EPROM.LEN := $3FFF;
    H4 := 1;
  end;
  case PARAM_NO of
  2 : begin
        H2 := H1 + EPROM.LEN - 1 + H4;
        if H2 <= BUF_END then E2 := 0;
      end;
  4 : begin
        if pos (PARAM [3], 'BIS') = 1
        then H2 := DECIMAL_CHECK (PARAM [4], E2);
      end;
  else
  end;
  if (E1 + E2 = 0) and (H2 - H1 <= EPROM.LEN - 1 + H4) then
  begin
    case EPROM.PGMD of
      'N': begin
        gotoxy(1,10);
        writeln ('                           PROGRAMMIERUNG LAEUFT.....');
        writeln;
        writeln ('                                 BITTE WARTEN !');
        writeln;
        writeln ('                           EPROM IM SOCKEL BELASSEN');
        writeln;
        writeln;
        writeln;
        writeln;
        writeln ('                                 <Return> Stop  ');
        gotoxy (5,24);
        write ('0 Bytes PROGRAM SECTION             PGMD :  Normal');
        PROG_VOLTAGE_ON;
        I := 0;
        CONTINUE := true;
        EPROM_ERROR_FLAG := false;
        repeat
          DATA_RAM := BUFFER [trunc (H1)];
          DATA_EPROM := PUT_EPROM (I, DATA_RAM);
          if (DATA_EPROM <> DATA_RAM) or keypressed
          then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, DATA_RAM);
          I := I + 1;
          if I = N1 then begin
            gotoxy (1,24);
            write (N1:5:0);
            gotoxy (13,24);
            N1 := N1 + 256;
          end;
          H1 := H1 + 1;
        until (H1 > H2) or not CONTINUE;
        RESET_SOCKET;
        H1 := H3;
      end;
      'O': begin
        gotoxy(1,10);
        writeln ('                           PROGRAMMIERUNG LAEUFT.....');
        writeln;
        writeln ('                                 BITTE WARTEN !');
        writeln;
        writeln ('                           EPROM IM SOCKEL BELASSEN');
        writeln;
        writeln;
        writeln;
        writeln;
        writeln ('                                   <Return> Stop');
        gotoxy (5,24);
        write ('0 Bytes PROGRAM SECTION             PGMD :  Normal');
        PROG_VOLTAGE_ON;
        I := 0;
        CONTINUE := true;
        EPROM_ERROR_FLAG := false;
        repeat
          DATA_RAM := BUFFER [trunc (H1)];
          DATA_EPROM := PUT_OEVPPEPROM (I, DATA_RAM);
          if (DATA_EPROM <> DATA_RAM) or keypressed
          then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, DATA_RAM);
          I := I + 1;
          if I = N1 then begin
            gotoxy (1,24);
            write (N1:5:0);
            gotoxy (13,24);
            N1 := N1 + 256;
          end;
          H1 := H1 + 1;
        until (H1 > H2) or not CONTINUE;
        RESET_SOCKET;
        H1 := H3;
      end;
      'A': begin
        EPROM.TIME := 0;
        gotoxy(1,10);
        writeln ('                           PROGRAMMIERUNG LAEUFT.....');
        writeln;
        writeln ('                                 BITTE WARTEN !');
        writeln;
        writeln ('                           EPROM IM SOCKEL BELASSEN');
        writeln;
        writeln;
        writeln;
        writeln;
        writeln ('                                 <Return> Stop       ');
        gotoxy (5,24);
        write ('0 BYTES INTERACTIVE SECTION        PGMD :  Fast A');
        PROG_VOLTAGE_ON;
        I := 0;
        CONTINUE := true;
        EPROM_ERROR_FLAG := false;
        repeat
          N2 := 0;
          repeat
            N2 := N2 + 1;
            DATA_RAM := BUFFER [trunc (H1)];
            DATA_EPROM := PUT_EPROM (I, DATA_RAM);
          until (DATA_EPROM = DATA_RAM) or (N2 = 15);
          if (DATA_EPROM <> DATA_RAM) or keypressed
          then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, DATA_RAM);
          I := I + 1;
          if I = N1 then begin
            gotoxy (1,24);
            write (N1:5:0);
            gotoxy (13,24);
            N1 := N1 + 256;
          end;
          H1 := H1 + 1;
        until (H1 > H2) or not CONTINUE;
        gotoxy (1,24);
        write ('    0 BYTES OVERPROGRAM SECTION        PGMD :  Fast A');
        gotoxy(1,19);
        clreol;
        EPROM.PROG [4] := EPROM.PROG [4] + 8;
        EPROM.VER [4] := EPROM.VER [4] + 8;
        PROG_VOLTAGE_ON;
        I := 0;
        N1 := 256;
        H1 := H3;
        EPROM.TIME := 1;
        repeat
          DATA_RAM := BUFFER [trunc (H1)];
          PUTO_EPROM (I, DATA_RAM);
          I := I + 1;
          if I = N1 then begin
            gotoxy (1,24);
            write (N1:5:0);
            gotoxy (13,24);
            N1 := N1 + 256;
          end;
          H1 := H1 + 1;
        until (H1 > H2) or not CONTINUE;
        EPROM.TIME := N3;
        RESET_SOCKET;
        H1 := H3;
      end;
      'B': begin
        EPROM.TIME := 0;
        gotoxy(1,10);
        writeln ('                           PROGRAMMIERUNG LAEUFT.....');
        writeln;
        writeln ('                                 BITTE WARTEN !');
        writeln;
        writeln ('                           EPROM IM SOCKEL BELASSEN');
        writeln;
        writeln;
        writeln;
        writeln;
        writeln ('                                 <Return> Stop  ');
        gotoxy (5,24);
        write ('0 BYTES PROGRAM SECTION            PGMD :  Fast B');
        PROG_VOLTAGE_ON;
        I := 0;
        CONTINUE := true;
        EPROM_ERROR_FLAG := false;
        repeat
          N2 := 0;
          EPROM.TIME := 0;
          repeat
            N2 := N2 + 1;
            DATA_RAM := BUFFER [trunc (H1)];
            DATA_EPROM := PUT_EPROM (I, DATA_RAM);
          until (DATA_EPROM = DATA_RAM) or (N2 = 15);
          if (DATA_EPROM <> DATA_RAM) or keypressed
          then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, DATA_RAM);
          EPROM.TIME := 4 * N2 - 1;
          PUTO_EPROM (I,DATA_RAM);
          I := I + 1;
          if I = N1 then begin
            gotoxy (1,24);
            write (N1:5:0);
            gotoxy (13,24);
            N1 := N1 + 256;
          end;
          H1 := H1 + 1;
        until (H1 > H2) or not CONTINUE;
        EPROM.TIME := N3;
        RESET_SOCKET;
        H1 := H3;
      end;
      'C': begin
        EPROM.TIME := 0;
        gotoxy(1,10);
        writeln ('                           PROGRAMMIERUNG LAEUFT.....');
        writeln;
        writeln ('                                 BITTE WARTEN !');
        writeln;
        writeln ('                           EPROM IM SOCKEL BELASSEN');
        writeln;
        writeln;
        writeln;
        writeln;
        writeln ('                                 <Return> Stop  ');
        gotoxy (5,24);
        write ('0 BYTES PROGRAM SECTION            PGMD :  Fast C');
        PROG_VOLTAGE_ON;
        I := 0;
        CONTINUE := true;
        EPROM_ERROR_FLAG := false;
        repeat
          N2 := 0;
          EPROM.TIME := 0;
          repeat
            N2 := N2 + 1;
            DATA_RAM := BUFFER [trunc (H1)];
            DATA_EPROM := PUT_EPROM (I, DATA_RAM);
          until (DATA_EPROM = DATA_RAM) or (N2 = 25);
          if (DATA_EPROM <> DATA_RAM) or keypressed
          then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, DATA_RAM);
          EPROM.TIME := 3 * N2 - 1;
          PUTO_EPROM (I, DATA_RAM);
          I := I + 1;
          if I = N1 then begin
            gotoxy (1,24);
            write (N1:5:0);
            gotoxy (13,24);
            N1 := N1 + 256;
          end;
          H1 := H1 + 1;
        until (H1 > H2) or not CONTINUE;
        EPROM.TIME := N3;
        RESET_SOCKET;
        H1 := H3;
      end;
      'D': begin
        EPROM.TIME := 0;
        gotoxy(1,10);
        writeln ('                           PROGRAMMIERUNG LAEUFT.....');
        writeln;
        writeln ('                                 BITTE WARTEN !');
        writeln;
        writeln ('                           EPROM IM SOCKEL BELASSEN');
        writeln;
        writeln;
        writeln;
        writeln;
        writeln ('                                 <Return> Stop  ');
        gotoxy (5,24);
        write ('0 BYTES PROGRAM SECTION            PGMD :  Fast D');
        PROG_VOLTAGE_ON;
        I := 0;
        CONTINUE := true;
        EPROM_ERROR_FLAG := false;
        repeat
          N2 := 0;
          EPROM.TIME := 0;
          repeat
            N2 := N2 + 1;
            DATA_RAM := BUFFER [trunc (H1)];
            DATA_EPROM := PUT_DEPROM (I, DATA_RAM);
          until (DATA_EPROM = DATA_RAM) or (N2 = 5);
          if (DATA_EPROM <> DATA_RAM) or keypressed
          then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, DATA_RAM);
          I := I + 1;
          if I = N1 then begin
            gotoxy (1,24);
            write (N1:5:0);
            gotoxy (13,24);
            N1 := N1 + 256;
          end;
          H1 := H1 + 1;
        until (H1 > H2) or not CONTINUE;
        EPROM.TIME := N3;
        RESET_SOCKET;
        H1 := H3;
      end;
    end;
    gotoxy(1,19);
    clreol;
    N1 := 256;
    gotoxy (1,24);
    write ('    0 BYTES VERIFY SECTION             ');
    gotoxy(1,1);
    H1 := DECIMAL_CHECK (PARAM [2], E1);
    E2 := 1;
    case PARAM_NO of
      2 : begin
        H2 := H1 + EPROM.LEN - 1 + H4;
        if H2 <= BUF_END then E2 := 0;
      end;
      4 : begin
        if pos (PARAM [3], 'BIS') = 1
        then H2 := DECIMAL_CHECK (PARAM [4], E2);
      end;
      else
      end;
      if (E1 + E2 = 0) and (H2 - H1 <= EPROM.LEN - 1 + H4) then
      begin
        I := 0;
        repeat
          DATA_RAM := BUFFER [trunc (H1)];
          DATA_EPROM := GET_EPROM (I);
          if DATA_RAM <> DATA_EPROM
          then CONTINUE := EPROM_ERROR_CONT (I, DATA_EPROM, DATA_RAM);
          I := I + 1;
          H1 := H1 + 1;
          if I = N1 then begin
            gotoxy (1,24);
            write (N1:5:0);
            gotoxy (13,24);
            N1 := N1 + 256;
          end;
        until (H1 > H2) or not CONTINUE;
        RESET_SOCKET;
      end
      else SYNTAX_ERROR;
    end
  else SYNTAX_ERROR;
end;
